clear all;
clc;



%% ========================================================================
%  IDENTIFIKACE SKOKU
%  ========================================================================
%% nacteni odezvy na skok ze souboru 
h1 = importdata('Mereni2_odezva_na_skok[mV].csv');
h1 = h1.data;
t = 0:2:(75*60)-1;

pocpodm = [20e-4,98,740];

%% upravy nactenych dat
h1 = h1(1:1625); % oriznuti, abych tam nemel ten linearni rust na konci prechodovky
t = t(1:1625);
h1 = h1-h1(1); % posun charakteristiky dolu na nulu
h1 = h1/1000; % prevod z mV na V
h1 = h1*(1/89.4e-3); % normalizace meho 89,4mW skoku na jednotkovy skok

%% predani odezvy funkci fminsearch, ktera ma za ukol najit tf
par = fminsearch('minim',pocpodm,[],h1,t); %pocatecni podminky [K,T1,T2]
K(1) = par(1); % ziskani hodnot zidentifikovanych parametru
T1(1) = par(2);
T2(1) = par(3);
Fs1=tf(K(1),[T1(1)*T2(1) T1(1)+T2(1) 1]); % zidentifikovana soustava
h2 = step (Fs1,t); %odezva na jednotkovy skok

%% vykresleni grafu
subplot(2,1,1);
plot(t,h1,'b') % vykresleni puvodni soustavy
hold on
axis tight;
xlabel ('as [s]');
ylabel ('vstupn napt [V]');
plot(t,h2,'r') % vykresleni zidentifikovane soustavy - melo by byt stejne (podobne)



%% ========================================================================
%  IDENTIFIKACE SESKOKU
%  ========================================================================
%% nacteni odezvy na skok ze souboru 
h1 = importdata('Mereni2_odezva_na_seskok[mV].csv');
h1 = h1.data;
t = 0:2:(102*60)-10;

%% upravy nactenych dat
h1 = h1(1:1625); % oriznuti, abych tam nemel ten linearni rust na konci prechodovky
t = t(1:1625);
h1 = h1-h1(20); % posun charakteristiky dolu na nulu
h1 = h1/1000; % prevod z mV na V
h1 = h1*(1/89.4e-3); % normalizace meho 89,4mW skoku na jednotkovy skok
h1 = -h1; % seskok -> skok

%% predani odezvy funkci fminsearch, ktera ma za ukol najit tf
par = fminsearch('minim',pocpodm,[],h1,t); %pocatecni podminky [K,T1,T2]
K(2) = par(1) % ziskani hodnot zidentifikovanych parametru
T1(2) = par(2)
T2(2) = par(3)
Fs2=tf(K(2),[T1(2)*T2(2) T1(2)+T2(2) 1]); % zidentifikovana soustava
h2 = step (Fs2,t); %odezva na jednotkovy skok

%% vykresleni grafu
subplot(2,1,2);
plot(t,h1,'b') % vykresleni puvodni soustavy
hold on
axis tight;
plot(t,h2,'r') % vykresleni zidentifikovane soustavy - melo by byt stejne (podobne)
xlabel ('as [s]');
ylabel ('vstupn napt [V]');

