clear all;
clc;



%% ========================================================================
%  IDENTIFIKACE SKOKU
%  ========================================================================
%% nacteni odezvy na skok ze souboru 
h1 = importdata('Mereni3_odezva_na_skok[mV].csv');
h1 = h1.data;
t = 0:3:(216*60)-1; % delka mereni

pocpodm = [20e-4,98,740];

%% upravy nactenych dat
h1 = h1(1:4000); % oriznuti, abych tam nemel ten linearni rust na konci prechodovky
t = t(1:4000);
h1 = h1-h1(1); % posun charakteristiky dolu na nulu
h1 = h1*38.61e-6; % prevod z K na V
h1 = h1*(1/357.9e-3); % normalizace meho 357,9mW skoku na jednotkovy skok

%% predani odezvy funkci fminsearch, ktera ma za ukol najit tf
par = fminsearch('minim',pocpodm,[],h1,t); %pocatecni podminky [K,T1,T2]
K(1) = par(1); % ziskani hodnot zidentifikovanych parametru
T1(1) = par(2);
T2(1) = par(3);
Fs1=tf(K(1),[T1(1)*T2(1) T1(1)+T2(1) 1]); % zidentifikovana soustava
h2 = step (Fs1,t); %odezva na jednotkovy skok

%% vykresleni grafu
subplot(2,2,1);
plot(t,h1,'b') % vykresleni puvodni soustavy
hold on
axis tight;
xlabel ('as [s]');
ylabel ('vstupn napt [V]');
plot(t,h2,'r') % vykresleni zidentifikovane soustavy - melo by byt stejne (podobne)



%% ========================================================================
%  IDENTIFIKACE SESKOKU
%  ========================================================================
%% nacteni odezvy na skok ze souboru 
h1 = importdata('Mereni3_odezva_na_seskok[mV].csv');
h1 = h1.data;
t = 0:3:(428*60)-10;

%% upravy nactenych dat
h1 = h1(1:4000); % oriznuti, abych tam nemel ten linearni rust na konci prechodovky
t = t(1:4000);
h1 = h1-h1(1); % posun charakteristiky dolu na nulu
h1 = h1*38.61e-6; % prevod z K na V
h1 = h1*(1/357.9e-3); % normalizace meho 357,9mW skoku na jednotkovy skok
h1 = -h1; % seskok -> skok

%% predani odezvy funkci fminsearch, ktera ma za ukol najit tf
par = fminsearch('minim',pocpodm,[],h1,t); %pocatecni podminky [K,T1,T2]
K(2) = par(1); % ziskani hodnot zidentifikovanych parametru
T1(2) = par(2);
T2(2) = par(3);
Fs2=tf(K(2),[T1(2)*T2(2) T1(2)+T2(2) 1]); % zidentifikovana soustava
h2 = step (Fs2,t); %odezva na jednotkovy skok

%% vykresleni grafu
subplot(2,2,2);
plot(t,h1,'b') % vykresleni puvodni soustavy
hold on
axis tight;
plot(t,h2,'r') % vykresleni zidentifikovane soustavy - melo by byt stejne (podobne)
xlabel ('as [s]');
ylabel ('vstupn napt [V]');

%% ========================================================================
%  IDENTIFIKACE SKOKU 2
%  ========================================================================
%% nacteni odezvy na skok ze souboru 
h1 = importdata('Mereni3_odezva_na_skok_2[mV].csv');
h1 = h1.data;
t = 0:3:(195*60)-1; % delka mereni

pocpodm = [20e-4,98,740];

%% upravy nactenych dat
h1 = h1(1:3899); % oriznuti, abych tam nemel ten linearni rust na konci prechodovky
t = t(1:3899);
h1 = h1-h1(34); % posun charakteristiky dolu na nulu
h1 = h1*38.61e-6; % prevod z K na V
h1 = h1*(1/89.4e-3); % normalizace meho 89,4mW skoku na jednotkovy skok

%% predani odezvy funkci fminsearch, ktera ma za ukol najit tf
par = fminsearch('minim',pocpodm,[],h1,t); %pocatecni podminky [K,T1,T2]
K(3) = par(1); % ziskani hodnot zidentifikovanych parametru
T1(3) = par(2);
T2(3) = par(3);
Fs1=tf(K(3),[T1(3)*T2(3) T1(3)+T2(3) 1]); % zidentifikovana soustava
h2 = step (Fs1,t); %odezva na jednotkovy skok

%% vykresleni grafu
subplot(2,2,3);
plot(t,h1,'b') % vykresleni puvodni soustavy
hold on
axis tight;
xlabel ('as [s]');
ylabel ('vstupn napt [V]');
plot(t,h2,'r') % vykresleni zidentifikovane soustavy - melo by byt stejne (podobne)



%% ========================================================================
%  IDENTIFIKACE SESKOKU 2
%  ========================================================================
%% nacteni odezvy na skok ze souboru 
h1 = importdata('Mereni3_odezva_na_seskok[mV].csv');
h1 = h1.data;
t = 0:3:(428*60)-10;

%% upravy nactenych dat
h1 = h1(1:4000); % oriznuti, abych tam nemel ten linearni rust na konci prechodovky
t = t(1:4000);
h1 = h1-h1(1); % posun charakteristiky dolu na nulu
h1 = h1*38.61e-6; % prevod z K na V
h1 = h1*(1/357.9e-3); % normalizace meho 357,9mW skoku na jednotkovy skok
h1 = -h1; % seskok -> skok

%% predani odezvy funkci fminsearch, ktera ma za ukol najit tf
par = fminsearch('minim',pocpodm,[],h1,t); %pocatecni podminky [K,T1,T2]
K(4) = par(1); % ziskani hodnot zidentifikovanych parametru
T1(4) = par(2);
T2(4) = par(3);
Fs2=tf(K(4),[T1(4)*T2(4) T1(4)+T2(4) 1]); % zidentifikovana soustava
h2 = step (Fs2,t); %odezva na jednotkovy skok

%% vykresleni grafu
subplot(2,2,4);
plot(t,h1,'b') % vykresleni puvodni soustavy
hold on
axis tight;
plot(t,h2,'r') % vykresleni zidentifikovane soustavy - melo by byt stejne (podobne)
xlabel ('as [s]');
ylabel ('vstupn napt [V]');

%% vypis vysledku
Kf2 = K/38.61e-6; % odecteni zesileni termoclanku
Kf2
T1
T2
